;**************
;* Interrupts *
;**************

;**************************************************************************************************
;*
;* Interrupt   - Interrupt_SWI3
;*               Interrupt_SWI4
;*               Interrupt_SWI5
;*               Interrupt_SWI6
;*               Interrupt_Alarm
;*               Interrupt_Z80
;*               Interrupt_Timer1
;*               Interrupt_Timer2
;*               Interrupt_Timer3
;*               Interrupt_Transmission
;*               Interrupt_Reception
;*               Interrupt_MicroDMA0
;*               Interrupt_MicroDMA1
;*               Interrupt_MicroDMA2
;*               Interrupt_MicroDMA3
;* Parameters  - none
;* Returns     - none
;* Description - Called when any unneeded interrupt occurs.
;* Author      - Steve Robb
;*
;**************************************************************************************************

SetDefaultIfInterruptUnused: Macro interruptname, {NoExpand}

	IfNDef interruptname

interruptname Equ Interrupt_Unused

	EndIf

	EndM

	SetDefaultIfInterruptUnused Interrupt_SWI3
	SetDefaultIfInterruptUnused Interrupt_SWI4
	SetDefaultIfInterruptUnused Interrupt_SWI5
	SetDefaultIfInterruptUnused Interrupt_SWI6
	SetDefaultIfInterruptUnused Interrupt_Alarm
	SetDefaultIfInterruptUnused Interrupt_VSync
	SetDefaultIfInterruptUnused Interrupt_Z80
	SetDefaultIfInterruptUnused Interrupt_Timer0
	SetDefaultIfInterruptUnused Interrupt_Timer1
	SetDefaultIfInterruptUnused Interrupt_Timer2
	SetDefaultIfInterruptUnused Interrupt_Timer3
	SetDefaultIfInterruptUnused Interrupt_Transmission
	SetDefaultIfInterruptUnused Interrupt_Reception
	SetDefaultIfInterruptUnused Interrupt_MicroDMA0
	SetDefaultIfInterruptUnused Interrupt_MicroDMA1
	SetDefaultIfInterruptUnused Interrupt_MicroDMA2
	SetDefaultIfInterruptUnused Interrupt_MicroDMA3


;*********************
;* End of Interrupts *
;*********************


