;
; Tell the AS assembler we want to code for NGPC and > 64K memory
;
        cpu 96C141
        maxmode on
        include "stddef96.inc"


;
; Standard NGPC cartridge header
;



HEADER_OFS      EQU     0200000H
STARTUP_OFS     EQU     0200040H

    org    HEADER_OFS    ;header of file
    db     " LICENSED BY SNK CORPORATION"    ; 28 bytes license string
    dd     STARTUP_OFS                       ; Program Counter
    dw     0000h                             ; Catalog number
    db     00h                               ; Cartridge size related?
    db     10h                               ; colour or b+w (10h = colour)
    db     "PICTURE VIEW"                    ; Game name (12 bytes)


    org STARTUP_OFS   ;start of code

    ; set up screen size 160x152
    ld   (08002h),000h  ; X offset
    ld   (08003h),000h  ; Y offset
    ld   (08004h),0a0h  ; X=160 
    ld   (08005h),098h  ; Y=152

    ; copy charset to character RAM
    ld bc,(ENDCHARSET-CHARSET)/2
    ld xde, 0a010h
    ld xhl, CHARSET
    ldirw (xde+),(xhl+)

    ; copy palette to character palette RAM
    ld bc, (ENDPALETTE-PALETTE)/2
    ld xde, 08300h
    ld xhl, PALETTE
    ldirw (xde+),(xhl+)

    ; copy TEXT to VRAM
    ld bc, (ENDTEXT-TEXT)/2
    ld xde, 09800h
    ld xhl, TEXT
    ldirw (xde+),(xhl+)

    ; background color
    ld de, (BACKGROUND)
    ld xhl, 083e0h
    ld (xhl), de

end jp end ; terminate

	include picdata.asm
;
; EOF
;

