	RAMDD	MV_PTR
	RAMDW	MV_COUNT
	RAMDW	MV_DELAY
	RAMDD	MV_WAV

	RAMDD	MV_CURPTR
	RAMDW	MV_CURCOUNT
	RAMDW	MV_CURDELAY
	RAMDD	MV_CURWAV

WAIT_H0	MACRO
	db	0c1h,009h,080h,023h	;	ld	c,(rRASV)
	db	0cbh,0cch,007h		;	and	c,7
	db	06eh,0f7h			;	jr	nz,wait_h0
	ENDM

WAIT_H1	MACRO
	db	0c1h,009h,080h,023h	;	ld	c,(rRASV)
	db	0cbh,0cch,007h		;	and	c,7
	db	066h,0f7h			;	jr	z,wait_h1
	ENDM

FILL0	MACRO
	ld		xde,_TILERAM
	ld		bc,8*20
	ldirw	(xde+),(xhl+)
	ld		xde,_SCR1PAL
	ld		bc,32
	ldirw	(xde+),(xhl+)
	ld		xde,xwa
	add		xwa,64
	ld		bc,20
	ldirw	(xde+),(xhl+)
	ENDM

FILL1	MACRO
	ld		xde,_TILERAM+20*16
	ld		bc,8*20
	ldirw	(xde+),(xhl+)
	ld		xde,_SCR1PAL+64
	ld		bc,32
	ldirw	(xde+),(xhl+)
	ld		xde,xwa
	add		xwa,64
	ld		bc,20
	ldirw	(xde+),(xhl+)
	ENDM

	;****************************************
	; Load new movie
	; xix : movie data ptr

mp_load
	push	bc
	push	xde
	push	xhl
	ld		xhl,xix
	ld		xde,MV_PTR
	ld		bc,4
	ldirw	(xde+),(xhl+)
	ld		(xde+),xiy
	ld		xhl,xix
	ld		bc,4
	ldirw	(xde+),(xhl+)

	pop		xhl
	pop		xde
	pop		bc
	ret

	;****************************************
	; Play current movie in emu

mp_play_emu
	push	xwa
	push	xhl
	push	xde
	push	bc

	ld		xhl,(MV_CURPTR)
	or		xhl,xhl
	jp		z,mp_nodata

	ld		xwa,_SCR1RAM

	FILL0
mp_wait_0
	ld		c,(rRASV)
	or		c,c
	jr		nz,mp_wait_0

	REPT	8

	WAIT_H1

	FILL1

	WAIT_H0
	WAIT_H1

	FILL0

	WAIT_H0

	ENDM

	WAIT_H1

	FILL1

	WAIT_H0
	WAIT_H1

	FILL0

mp_end_frame
	decw	(MV_CURDELAY)
	jr		nz,mp_nodata

	ld		bc,(MV_DELAY)
	ld		(MV_CURDELAY),bc

	decw	(MV_CURCOUNT)
	jr		nz,mp_notend

	ld		xhl,(MV_PTR)
	ld		bc,(MV_COUNT)
	ld		(MV_CURCOUNT),bc

mp_notend
	ld		(MV_CURPTR),xhl

mp_nodata
	pop		bc
	pop		xde
	pop		xhl
	pop		xwa

	ret

	;****************************************
	; Play current movie on real HW

mp_play_hw
	push	xwa
	push	xhl
	push	xde
	push	bc

	ld		xhl,(MV_CURPTR)
	or		xhl,xhl
	jp		z,mp_nodata

	ld		xwa,_SCR1RAM

	FILL0

mp_wait_0_hw
	ld		c,(rRASV)
	or		c,c
	jr		nz,mp_wait_0_hw

	REPT	8

	FILL1

	WAIT_H0

	FILL0

	WAIT_H0

	ENDM

	FILL1

	WAIT_H0

	FILL0

	jp		mp_end_frame

