// PocketSendDlg.cpp : implementation file
//

/* 
Credits
	Reiner - ReadPlus source
	Dark Fader - PokeLink source
	?? - WinIO
	LikSang
	Steve - Code help
*/

/* to do


  make sure that there is all 0xFFs at 0x1FC000


BTW, it seems like you're not closing the file after you do Cart->File.  
I tried to load it into MHE after dumping it, and got a sharing violation 
while PocketSent was still running.

I had the same problem.

Add NGPCpack.ngp as a resource.  
Then "I think you just use LoadResource to get a handle to it, 
  then use LockResource to get a pointer to it."

You really need to put a 4Mb file as the first ROM.
If you don't, it may violate this rule.
"The last  block of the flash memory (4 Mbit: block 10, 8 Mbit: block 18, and 16 Mbit: block 34) is reserved for use by the system program.  Please do not use these blocks for program code, data, or back up area."

31	F16_B31	0x1F0000~0x1F7FFF	32K (0x8000)
32	F16_B32	0x1F8000~0x1F9FFF	8K (0x2000)
33	F16_B33	0x1FA000~0x1FBFFF	8K (0x2000)
34	F16_B34	0x1FC000~0x1FFFFF	16K (0x4000)

*/

#include "stdafx.h"
#include "PocketSend.h"
#include "PocketSendDlg.h"
#include "pokelink.h"


#include <fstream.h>
#include <iomanip.h>

#define LINKER_TEMP_FILE_NAME "NGPCpack.~~~"
//#define MULTI_ROM_MENU_FILE_NAME "NGPCpack.ngp"
#define CART_INFO_FILE_NAME "CartInfo.txt"
#define FLAVOR_URL "http://flavor.8k.com/"
#define LIKSANG_URL "http://www.lik-sang.com/catalog/default.php?likref=ngpc-win"

#define NGPCPACK_SIZE 0x4000

//CString MULTI_ROM_MENU_FILE;
CString LINKER_TEMP_FILE;
CString CART_INFO_FILE;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define POLL_TIMER 5

bool linkerPresent = true;
int sending = 0;
CWnd *Menu2CartButton=NULL, *File2CartButton=NULL, *Cart2FileButton=NULL;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	void writeCartInfo();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnDestroy();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	CFont    m_Font;                                // Underline font if necessary
	BOOL m_bOverControl;
	DECLARE_MESSAGE_MAP()
	void OnUrl();
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT

	m_bOverControl = FALSE;
}

void CAboutDlg::writeCartInfo()
{
	unsigned long i;
	BYTE tempByte;

	if(sending)
		return;  //don't do it!

	tempByte = ManufID();
    if(tempByte == 0 || tempByte == 0x3F || tempByte == 0xFF)
		return;  //no cart present

	ofstream outFile(CART_INFO_FILE, ios::app | ios::out);
	//outFile.seekp(0,ios::end);

	outFile << setiosflags(ios::showbase | ios::adjustfield | ios::internal)
	        << setfill('0');

	outFile << "Manufacturer ID = " << hex << setw(4) << (int)tempByte << endl;
	outFile << "Device ID = " << hex << setw(4) << (int)DeviceID() << endl;
	outFile << "Device ID Chip #2 = " << setw(4) << hex << (int)DeviceID(1) << endl;
	outFile << "Cart Name = " << GetCartNameString() << endl;
	unsigned long cartSize = DetectSize();
	outFile << "Cart Size = " << dec << (int)(cartSize>>17) << "Mbit" << endl;

	outFile << resetiosflags(ios::adjustfield | ios::internal)
		    << setiosflags(ios::showbase /*| ios::adjustfield | ios::internal*/)
	        << setfill(' ');

	for(i = 0; i < cartSize; i += 0x10000)
	{
	   /*if((SectorProtVerify(i + 0x10000) & 0xFE) != 0)
		   break;*/

	   outFile << "i=" << hex << setw(8) << i << " protected=" << dec << (int)SectorProtVerify(i) << endl;

	   if(((i >> 16) == 0x1F) || i == cartSize-0x10000)
	   {
		   outFile << "i=" << hex << setw(8) << i+0x8000 << " protected=" << dec << (int)SectorProtVerify(i+0x8000) << endl;
		   outFile << "i=" << hex << setw(8) << i+0xA000 << " protected=" << dec << (int)SectorProtVerify(i+0xA000) << endl;
		   outFile << "i=" << hex << setw(8) << i+0xC000 << " protected=" << dec << (int)SectorProtVerify(i+0xC000) << endl;
	   }
	}

	/*i-=0x10000;
	outFile << "i=" << hex << setw(8) << i+0x8000 << " protected=" << dec << (int)SectorProtVerify(i+0x8000) << endl;
	outFile << "i=" << hex << setw(8) << i+0xA000 << " protected=" << dec << (int)SectorProtVerify(i+0xA000) << endl;
	outFile << "i=" << hex << setw(8) << i+0xC000 << " protected=" << dec << (int)SectorProtVerify(i+0xC000) << endl;
	*/
	

	outFile << endl;
	outFile.close();
}

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	GetDlgItem(IDC_URL)->SetWindowText(FLAVOR_URL);

	//underline the URL
	LOGFONT lf;
	GetFont()->GetLogFont(&lf);
	lf.lfUnderline = true;
	m_Font.DeleteObject();
	m_Font.CreateFontIndirect(&lf);
	GetDlgItem(IDC_URL)->SetFont(&m_Font);

	writeCartInfo();

	return TRUE;
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_CTLCOLOR()
	ON_WM_DESTROY()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPocketSendDlg dialog

DWORD GetEXEDir(CString &dir)
{ 
	char szBuffer[256];
	DWORD retval; 
	retval = GetModuleFileName( AfxGetInstanceHandle(), szBuffer, 128 );
	
	if (!retval)
	{
		dir = "";
	}
	else
	{
		char *p = strrchr( (const char*)szBuffer, '\\' );
		if (p!=NULL) *(++p) = '\0';
		dir = (LPTSTR)szBuffer;
	} 
	return retval;
}

CPocketSendDlg::CPocketSendDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPocketSendDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPocketSendDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hSmallIcon = (HICON)::LoadImage(AfxGetResourceHandle(),
        MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON,
        16, 16, 0);

	m_bOverControl = FALSE;
}

void CPocketSendDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPocketSendDlg)
	DDX_Control(pDX, IDL_FILES, m_ctrlFiles);
	DDX_Control(pDX, IDC_PROGRESS, Progress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPocketSendDlg, CDialog)
	//{{AFX_MSG_MAP(CPocketSendDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDB_DELETE, OnDelete)
	ON_BN_CLICKED(IDMENU2CART, OnMenu2Cart)
	ON_BN_CLICKED(IDMENU2FILE, OnMenu2File)
	ON_BN_CLICKED(IDFILE2CART, OnFile2Cart)
	ON_BN_CLICKED(IDCART2FILE, OnCart2File)
	ON_BN_CLICKED(IDABOUT, OnAbout)
	ON_BN_CLICKED(IDB_ADDFILES, OnAddFiles)
	ON_WM_TIMER()
	ON_WM_CTLCOLOR()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_LIKSANG, OnLiksangClicked)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_PORT_BUTTON, OnPortButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPocketSendDlg message handlers

void CPocketSendDlg::initLinker()
{
	static int initialized = 0;
	char tempStr[6];

	GetDlgItem(IDC_PORT_BUTTON)->GetWindowText(tempStr, 6);
	if(strcmp(tempStr, GetPortValString()) != 0)
		SetPortValString(tempStr);
		//GetDlgItem(IDC_PORT_BUTTON)->SetWindowText(GetPortValString());

	linkerPresent = true;
	if(ActionInit(&Progress) != 0) //returns non-0 on error
	{
		if(ActionInit(&Progress) != 0) //returns non-0 on error
		{
			AfxMessageBox("Can't initialize Pocket Linker", MB_ICONEXCLAMATION);
			//disable the send buttons
			linkerPresent = false;
			//EnableLinkerButtons(false);
		}
	}
	EnableLinkerButtons(linkerPresent);

	GetDlgItem(IDC_PORT_TYPE)->SetWindowText(GetPortTypeString());
	GetDlgItem(IDC_CARTSIZE)->SetWindowText(GetCartSizeString());		
	GetDlgItem(IDC_CARTNAME)->SetWindowText(GetCartNameString());		
}

BOOL CPocketSendDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, 1);			// Set big icon
	SetIcon(m_hSmallIcon, 0);		// Set small icon
	
	// TODO: Add extra initialization here
	m_ctrlFiles.InsertColumn( 0, "ROM Name", LVCFMT_LEFT, 401);
	m_ctrlFiles.InsertColumn( 1, "Size", LVCFMT_LEFT, 60);
	m_ctrlFiles.InsertColumn( 2, "FileName", LVCFMT_LEFT, 0);
	m_ctrlFiles.InsertColumn( 3, "FileSize", LVCFMT_LEFT, 0);

	
	//pProgress = (CGradientProgressCtrl *)GetDlgItem( IDC_PROGRESS);
	//pProgress = (CProgressCtrl *)GetDlgItem( IDC_PROGRESS);
	Progress.SetRange(0 , 1000);  // min 0 max 1000


	//m_cProgress.SetRange(0, m_nRange);
	//m_cProgress.ShowPercent(true);

	Progress.SetStartColor(RGB(0xFF,0x7F,0));
	//Progress.SetStartColor((Progress.GetBkColor() & RGB(0,0xFF,0)) | RGB(0xFF,0,0));
	Progress.SetEndColor(RGB(0,0xFF,0));
	Progress.SetTextColor(RGB(0,0,0));
	//Progress.SetBkColor(RGB(0,0,0));
	Progress.SetPos( 0 );  //set starting position

	GetCurrentDirectory(255, workingDir);
	
	Menu2CartButton = GetDlgItem(IDMENU2CART);
	File2CartButton = GetDlgItem(IDFILE2CART);
	Cart2FileButton = GetDlgItem(IDCART2FILE);

	//disable MENU2____
	GetDlgItem(IDMENU2CART)->EnableWindow(false);
	GetDlgItem(IDMENU2FILE)->EnableWindow(false);

	initLinker();

	SetTimer(POLL_TIMER, 2000, NULL);

	//underline the URL
	//the underline screws up the g on "Sang"
	LOGFONT lf;
	GetFont()->GetLogFont(&lf);
	lf.lfUnderline = true;
	m_Font.DeleteObject();
	m_Font.CreateFontIndirect(&lf);
	GetDlgItem(IDC_LIKSANG)->SetFont(&m_Font);
	

	//MULTI_ROM_MENU_FILE = workingDir;
	//MULTI_ROM_MENU_FILE += "\\";
	//MULTI_ROM_MENU_FILE += MULTI_ROM_MENU_FILE_NAME;

	LINKER_TEMP_FILE = workingDir;
	LINKER_TEMP_FILE += "\\";
	LINKER_TEMP_FILE += LINKER_TEMP_FILE_NAME;

	CART_INFO_FILE = workingDir;
	CART_INFO_FILE += "\\";
	CART_INFO_FILE += CART_INFO_FILE_NAME;

	//initialize the IDR_NGPCPACK resource
	HRSRC hrsrc = FindResource(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_NGPCPACK), "NGPCpack");
	HGLOBAL hglb = LoadResource(AfxGetInstanceHandle(), hrsrc);
	NGPCpackArray = (BYTE *)LockResource(hglb);

	totalFileSize = NGPCPACK_SIZE;  //this better be right :)

	/*CFile file(MULTI_ROM_MENU_FILE, CFile::modeRead );
	if(!file)
	{
		CString errMsg;
		errMsg.Format("Error: %s not found!", MULTI_ROM_MENU_FILE); 
		totalFileSize = 0;
	}
	else
	{
		totalFileSize = file.GetLength();
		file.Close();
	}*/
	totalFileSize += 1048576;

	numOf16MbROMs = 0;

	CString strTemp;
	if((totalFileSize / 131072) > 0)  
	{
		//turn bytes into Mb
		strTemp.Format( "%0.3fMb", totalFileSize / 131072.0 );
	}
	else
	{
		//turn into Kb
		strTemp.Format( "%uKb", totalFileSize / 128 );
	}
	GetDlgItem(IDC_TOTALSIZE)->SetWindowText(strTemp);

	m_hAccel = ::LoadAccelerators(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_ACCELERATOR1));
    ASSERT(m_hAccel);


	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CPocketSendDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message >= WM_KEYFIRST && pMsg->message <= WM_KEYLAST) 
	{
		if (::TranslateAccelerator(m_hWnd, m_hAccel, pMsg))
			return TRUE;
	} 
	return CDialog::PreTranslateMessage(pMsg);
}

void CPocketSendDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
		dlgAbout.GetDlgItem(IDC_URL)->SetWindowText(FLAVOR_URL);
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPocketSendDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPocketSendDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


LRESULT CPocketSendDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{

	switch ( message )
	{
		case UM_FILESDROPPED:
		{
			AddFiles( ( int )wParam, ( CString* )lParam );
			break;
		}
	}

	return CDialog::WindowProc(message, wParam, lParam);
}

int CALLBACK CPocketSendDlg::Compare(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	//CMyListCtrl *mList = (CMyListCtrl *)lParamSort;
    DWORD s1 = (DWORD) lParam1;
    DWORD s2 = (DWORD) lParam2;
	int retVal;

	if(s1 < s2)
		retVal = 1;
	else if(s1 > s2)
		retVal = -1;
	else
		retVal = 0;

    return retVal;
}

void CPocketSendDlg::AddFiles( int iCount, CString* pstrFiles )
{

	for ( int i = 0; i < iCount; i++ )
	{
		char ROMName[13];
		BYTE lStr[27];
		CFile file( pstrFiles[ i ], CFile::modeRead );
		unsigned len = file.GetLength();

		// Length: 27 / 0x0000001B
		const unsigned char licensedStr[27] = 
		{   //LICENSED BY SNK CORPORATION (I think)
			0x4C, 0x49, 0x43, 0x45, 0x4E, 0x53, 0x45, 0x44, 0x20, 0x42, 0x59, 
			0x20, 0x53, 0x4E, 0x4B, 0x20, 0x43, 0x4F, 0x52, 0x50, 0x4F, 0x52, 
			0x41, 0x54, 0x49, 0x4F, 0x4E 
		} ;

		file.Seek(0x01,CFile::begin);
		file.Read(lStr, 27);

		file.Seek(0x24,CFile::begin);
		file.Read(ROMName, 12);
		ROMName[12]=0;

		if(len > 0x200000)  //too large
		{
			file.Close();
			continue;
		}
		else if(len == 0x200000)  //can have one of these
		{
			numOf16MbROMs++;
		}
		else if(len > 0x100000)  //too large
		{
			file.Close();
			continue;
		}


		if((len % 0x80000) == 0)  //if it's a perfect multiple of 4Mbit
			len -= 0x4000;//strip off the last 0x4000

		//unsigned chopped = 0;
		unsigned char readBuf[0x10];
		unsigned char prevByte;

		int changed = 0;
		while(1)
		{
			file.Seek(len-0x10, CFile::begin);
			file.Read(readBuf, 0x10);


			for(int i = 0; i < 0x10; i++)
			{
				if(readBuf[i] == 0xFF || readBuf[i] == 0x00)
				{
					if(i == 0)
						prevByte = readBuf[i];
					else
						if(prevByte != readBuf[i])
						{
							if(changed)
								break;
							else
								changed = 1;  //get 1 change
						}
				}
				else
					break;
			}

			if(i != 0x10)
				break;

			len -= 0x10;
		} 

		file.Close();

		if(memcmp(&lStr[9], &licensedStr[9], 18) != 0)//only test "BY SNK CORPORATION"
			continue;   //not a valid ROM

		LVITEM sItem;
		CString strTemp;
		if((len / 131072) > 0)  
		{
			//turn bytes into Mb
			strTemp.Format( "%0.3fMb", len / 131072.0 );
		}
		else
		{
			//turn into Kb
			strTemp.Format( "%uKb", len / 128 );
		}

		memset( &sItem, 0, sizeof( sItem ));
		sItem.mask = LVIF_TEXT;
		sItem.iItem = m_ctrlFiles.GetItemCount();

		sItem.pszText = ROMName;//pstrFiles[ i ].GetBuffer( MAX_PATH );
		int iIndex = m_ctrlFiles.InsertItem( &sItem );

		m_ctrlFiles.SetItemText( iIndex, 1, strTemp );
		m_ctrlFiles.SetItemText( iIndex, 2, pstrFiles[ i ].GetBuffer( MAX_PATH ) );
		m_ctrlFiles.SetItemData( iIndex, len);

		totalFileSize += len;
	}

	CString strTemp;
	if((totalFileSize / 131072) > 0)  
	{
		//turn bytes into Mb
		strTemp.Format( "%0.3fMb", totalFileSize / 131072.0 );
	}
	else
	{
		//turn into Kb
		strTemp.Format( "%uKb", totalFileSize / 128 );
	}
	GetDlgItem(IDC_TOTALSIZE)->SetWindowText(strTemp);

	if((m_ctrlFiles.GetItemCount() > 0) && (totalFileSize <= 4194304))  //if more than just menu and 32Mb or less
	{
		//enable MENU2____
		if(linkerPresent)
			GetDlgItem(IDMENU2CART)->EnableWindow(true);
		GetDlgItem(IDMENU2FILE)->EnableWindow(true);
	}
	else
	{
		//disable MENU2____
		GetDlgItem(IDMENU2CART)->EnableWindow(false);
		GetDlgItem(IDMENU2FILE)->EnableWindow(false);
	}

	m_ctrlFiles.SortItems(Compare, (DWORD) &m_ctrlFiles);
}



void CPocketSendDlg::OnDelete() 
{
	int iCount = m_ctrlFiles.GetSelectedCount();
	if ( iCount > 1 )
	{
		CString strTemp;
		strTemp.Format( "Do you really want to remove the selected %d files?", iCount);
		if ( AfxMessageBox( strTemp, MB_YESNO | MB_ICONASTERISK ) == IDNO )
			return;
	}

	while ( m_ctrlFiles.GetSelectedCount() )
	{
		POSITION pos = m_ctrlFiles.GetFirstSelectedItemPosition();
		if( pos )
		{
			int iIndex = m_ctrlFiles.GetNextSelectedItem( pos );

			CFile file(m_ctrlFiles.GetItemText( iIndex, 2 ), CFile::modeRead );
			totalFileSize -= m_ctrlFiles.GetItemData(iIndex);
			if(file.GetLength() == 0x200000)
				numOf16MbROMs--;
			file.Close();

			m_ctrlFiles.DeleteItem( iIndex );
		}
	}

	CString strTemp;
	if((totalFileSize / 131072) > 0)  
	{
		//turn bytes into Mb
		strTemp.Format( "%0.3fMb", totalFileSize / 131072.0 );
	}
	else
	{
		//turn into Kb
		strTemp.Format( "%uKb", totalFileSize / 128 );
	}
	GetDlgItem(IDC_TOTALSIZE)->SetWindowText(strTemp);

	if((m_ctrlFiles.GetItemCount() > 0) && (totalFileSize <= 4194304))  //if more than just menu
	{
		//enable MENU2____
		if(linkerPresent)
			GetDlgItem(IDMENU2CART)->EnableWindow(true);
		GetDlgItem(IDMENU2FILE)->EnableWindow(true);
	}
	else
	{
		//disable MENU2____
		GetDlgItem(IDMENU2CART)->EnableWindow(false);
		GetDlgItem(IDMENU2FILE)->EnableWindow(false);
	}
}


CString writeFile;
UINT CPocketSendDlg::ActionWriteThread( LPVOID ObjPtr )
{
	sending = 1;
	EnableLinkerButtons(false);

	char filename[500];
	strcpy(filename, (const char *)writeFile);

	time_t startTime, endTime;

	startTime = time(NULL);
	ActionWrite(filename);
	endTime = time(NULL);

	if(strcmp(writeFile, LINKER_TEMP_FILE) == 0)
	{
		CFileStatus TempStatus;
		if (CFile::GetStatus(filename, TempStatus)) //check if file exists
		{
			CFile::Remove(filename);  //it better be there
			/*if (TempStatus.m_attribute & CFile::directory)
				<file exists, and is a directory>*/
		}
	}

	EnableLinkerButtons(true);
	sending = 0;

	char tempMessage[80];
	wsprintf(tempMessage, "Done Writing\n%ds elapsed", endTime-startTime);
	AfxMessageBox(tempMessage);
	ActionClearProgress();
	return 0;
}

unsigned long CPocketSendDlg::SetupMultiROMFile(CString writeFile)
{
    unsigned char romTable[0x800];
	unsigned long romTablePtr = 0;
	unsigned long bytesWritten = 0;
	unsigned long outFileSize;

	memset(romTable, 0xFF, sizeof(romTable));

    if(totalFileSize > 4194304)
	{
		CString strTemp;
		strTemp.Format( "%uMb is too big for this cart!\nPlease remove some files.", totalFileSize / 131072 );
		AfxMessageBox(strTemp, MB_ICONEXCLAMATION);
		return 0;
	}

	unsigned char szTemp[0x80000];
	unsigned long read;

	CFile outFile(writeFile, CFile::modeCreate | CFile::modeWrite);
	CFile inFile;

	/*inFile.Open(MULTI_ROM_MENU_FILE, CFile::modeRead );
    do
	{
		read = inFile.Read(szTemp, sizeof(szTemp)); 
		outFile.Write(szTemp, read);
		bytesWritten += read;
	} while(read == sizeof(szTemp));
	inFile.Close();*/
	outFile.Write(NGPCpackArray, NGPCPACK_SIZE);
	bytesWritten += NGPCPACK_SIZE;

	memset(szTemp, 0xFF, sizeof(szTemp));

	while(bytesWritten < 1048576)
	{
		unsigned long need;
		unsigned long toWrite;

		need = 1048576 - bytesWritten;
		if(need < sizeof(szTemp))
           toWrite = need;
		else
		   toWrite = sizeof(szTemp);

	    outFile.Write(szTemp, toWrite);
		bytesWritten += toWrite;
	}
	 
	//This is a hack to fix the problem when a 8Mb ROM is first
	//check to see if the 1st ROM is > 4Mb

    romTable[0] = m_ctrlFiles.GetItemCount();
	romTablePtr = 1;

	int i = 0;
	{   //do the loop once with i = 0 (LARGEST ROM)
		inFile.Open( m_ctrlFiles.GetItemText( i, 2 ), CFile::modeRead );
		unsigned len = m_ctrlFiles.GetItemData(i);

        unsigned fileBytesToWrite = len;
		if(len > 0x100000) //if it's the first one, and greater than 8Mbit (should be 16Mbit)
		{
			inFile.Seek(0x100000, CFile::begin); //jump to the middle

			do
			{
				read = inFile.Read(szTemp, sizeof(szTemp)); 
				if(read > fileBytesToWrite)
					read = fileBytesToWrite;
				outFile.Write(szTemp, read);
				bytesWritten += read;
				fileBytesToWrite -= read;
			} while(read == sizeof(szTemp));

			inFile.Seek(0, CFile::begin); //jump back to the start
			len = 0x100000;
		}

		unsigned location = bytesWritten;
		location += 0x200000;
		if(location >= 0x400000)
			location += 0x400000;  //upper 16Mbit

		romTable[romTablePtr] = location & 0xFF;
		romTable[romTablePtr+1] = (location >> 8) & 0xFF;
		romTable[romTablePtr+2] = (location >> 16) & 0xFF;
		romTable[romTablePtr+3] = (location >> 24) & 0xFF;
		romTable[romTablePtr+4] = len & 0xFF;
		romTable[romTablePtr+5] = (len >> 8) & 0xFF;
		romTable[romTablePtr+6] = (len >> 16) & 0xFF;
		romTable[romTablePtr+7] = (len >> 24) & 0xFF;
		romTablePtr += 0x10;

		do
		{
			read = inFile.Read(szTemp, sizeof(szTemp)); 
			if(read > fileBytesToWrite)
				read = fileBytesToWrite;
			outFile.Write(szTemp, read);
			bytesWritten += read;
			fileBytesToWrite -= read;
		} while(fileBytesToWrite);

		inFile.Close();
	}

	//now, do it from the SMALLEST to the LARGEST (for packing reasons)
	for (i = (m_ctrlFiles.GetItemCount() - 1); i > 0 ; i-- )
	{
		inFile.Open( m_ctrlFiles.GetItemText( i, 2 ), CFile::modeRead );
		unsigned len = m_ctrlFiles.GetItemData(i);

        unsigned fileBytesToWrite = len;

		//if we haven't hit the 0x1FC000 mark
		//  but the next write will break that mark
		//  we need to fill
		if((bytesWritten <= 0x1FC000) && ((bytesWritten + len) > 0x1FC000))
		{
			memset(szTemp, 0xFF, sizeof(szTemp));

			while(bytesWritten < 0x200000)
			{
				unsigned long need;
				unsigned long toWrite;

				need = 0x200000 - bytesWritten;
				if(need < sizeof(szTemp))
				   toWrite = need;
				else
				   toWrite = sizeof(szTemp);

				outFile.Write(szTemp, toWrite);
				bytesWritten += toWrite;
			}
		}

		unsigned location = bytesWritten;
		location += 0x200000;
		if(location >= 0x400000)
			location += 0x400000;  //upper 16Mbit

		romTable[romTablePtr] = location & 0xFF;
		romTable[romTablePtr+1] = (location >> 8) & 0xFF;
		romTable[romTablePtr+2] = (location >> 16) & 0xFF;
		romTable[romTablePtr+3] = (location >> 24) & 0xFF;
		romTable[romTablePtr+4] = len & 0xFF;
		romTable[romTablePtr+5] = (len >> 8) & 0xFF;
		romTable[romTablePtr+6] = (len >> 16) & 0xFF;
		romTable[romTablePtr+7] = (len >> 24) & 0xFF;
		romTablePtr += 0x10;

		do
		{
			read = inFile.Read(szTemp, sizeof(szTemp)); 
			if(read > fileBytesToWrite)
				read = fileBytesToWrite;
			outFile.Write(szTemp, read);
			bytesWritten += read;
			fileBytesToWrite -= read;
		} while(fileBytesToWrite);
		inFile.Close();
	}

	memset(szTemp, 0xFF, sizeof(szTemp));
	while(bytesWritten < 0x3FC000)
	{
		unsigned long need;
		unsigned long toWrite;

		need = 0x3FC000 - bytesWritten;
		if(need < sizeof(szTemp))
           toWrite = need;
		else
		   toWrite = sizeof(szTemp);

	    outFile.Write(szTemp, toWrite);
		bytesWritten += toWrite;
	}

	/*inFile.Open(MULTI_ROM_MENU_FILE, CFile::modeRead );
    do
	{
		read = inFile.Read(szTemp, sizeof(szTemp)); 

		unsigned i;
		unsigned eds = 0;
		if(read < sizeof(szTemp))
		{
			for(i = 0; i < read && eds < 4; i++)
			{
				if(szTemp[i] == 0xED)
					eds++;
				else
					eds = 0;
			}
			memcpy(&szTemp[i], romTable, romTable[0] * 0x10 + 1);
			outFile.Write(szTemp, (read-(read-i))+(romTable[0] * 0x10 + 1));
			bytesWritten += (read-(read-i))+(romTable[0] * 0x10 + 1);
		}
		else
		{
			outFile.Write(szTemp, read);
			bytesWritten += read;
		}
	} while(read == sizeof(szTemp));
	inFile.Close();*/
	
	memcpy(szTemp, NGPCpackArray, NGPCPACK_SIZE);
		unsigned eds = 0;
			for(i = 0; i < NGPCPACK_SIZE && eds < 4; i++)
			{
				if(szTemp[i] == 0xED)
					eds++;
				else
					eds = 0;
			}
			memcpy(&szTemp[i], romTable, romTable[0] * 0x10 + 1);
			outFile.Write(szTemp, (NGPCPACK_SIZE-(NGPCPACK_SIZE-i))+(romTable[0] * 0x10 + 1));
			bytesWritten += (NGPCPACK_SIZE-(NGPCPACK_SIZE-i))+(romTable[0] * 0x10 + 1);


	memset(szTemp, 0xFF, sizeof(szTemp));
	while(bytesWritten < 0x400000)
	{
		unsigned long need;
		unsigned long toWrite;

		need = 0x400000 - bytesWritten;
		if(need < sizeof(szTemp))
           toWrite = need;
		else
		   toWrite = sizeof(szTemp);

	    outFile.Write(szTemp, toWrite);
		bytesWritten += toWrite;
	}
	

    outFileSize = outFile.GetLength();
	outFile.Close();
	return outFileSize;
}

void CPocketSendDlg::OnMenu2Cart() 
{
	if(sending)
		return;  //hack to prevent double-send attempt

	if((DetectSize() >> 19) == 0)  //the lower 19 bits should all be 0, anyway
	{
		AfxMessageBox("Please insert a cart before writing!");
		return;
	}

	if(numOf16MbROMs > 1)
	{
		AfxMessageBox("Only one 16Mbit ROM allowed!", MB_ICONEXCLAMATION);
		return;
	}

	if(SetupMultiROMFile(LINKER_TEMP_FILE) > 0x400000)
	{
		AfxMessageBox("ERROR: This combination of files results\nin a file that is over 32Mb!", MB_ICONEXCLAMATION);
		return;
	}

	if(AfxMessageBox("Start Writing?", MB_YESNO | MB_ICONQUESTION) == IDNO)
	{
		CFileStatus TempStatus;
		if (CFile::GetStatus(LINKER_TEMP_FILE, TempStatus)) //check if file exists
			CFile::Remove(LINKER_TEMP_FILE);  //it better be there
		return;
	}

	writeFile = LINKER_TEMP_FILE;
	AfxBeginThread( CPocketSendDlg::ActionWriteThread, this );
}

void CPocketSendDlg::OnMenu2File() 
{
	if(numOf16MbROMs > 1)
	{
		AfxMessageBox("Only one 16Mbit ROM allowed!", MB_ICONEXCLAMATION);
		return;
	}

	CFileDialog outFileDlg(false, "ngp", "*.ngp", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "NGPC Files (*.ngp)|*.ngp|All Files (*.*)|*.*||", this);
	if(outFileDlg.DoModal() == IDCANCEL)
		return;

	if(SetupMultiROMFile(outFileDlg.GetPathName()) > 0x400000)
	{
		AfxMessageBox("WARNING: This combination of files results\nin a file that is over 32Mb!", MB_ICONEXCLAMATION);
	}
}

int CPocketSendDlg::DestroyWindow()
{
	KillTimer(POLL_TIMER);

	ActionShutdown();  //this really should be done on shutdown of application

	CDialog::DestroyWindow();
	return true;
}



void CPocketSendDlg::OnFile2Cart() 
{
	if(sending)
		return;  //hack to prevent double-send attempt

	if((DetectSize() >> 19) == 0)  //the lower 19 bits should all be 0, anyway
	{
		AfxMessageBox("Please insert a cart before writing!");
		return;
	}

	CFileDialog inFile(true, "ngp", "*.ngp", /*OFN_ALLOWMULTISELECT |*/ OFN_READONLY | OFN_HIDEREADONLY, "NGPC Files (*.ngp)|*.ngp|All Files (*.*)|*.*||", this);
	if(inFile.DoModal() == IDCANCEL)
		return;
	
	writeFile = inFile.GetPathName();
	AfxBeginThread( ActionWriteThread, this ); 
}

CString readFile;
UINT CPocketSendDlg::ActionReadThread( LPVOID ObjPtr )
{
	sending = 1;
	EnableLinkerButtons(false);
	char filename[500];
	strcpy(filename, (const char *)readFile);

	time_t startTime, endTime;

	startTime = time(NULL);
	ActionBackup(filename);
	endTime = time(NULL);


	EnableLinkerButtons(true);
	sending = 0;
	char tempMessage[80];
	wsprintf(tempMessage, "Done Reading\n%ds elapsed", endTime-startTime);
	AfxMessageBox(tempMessage);
	ActionClearProgress();
	return 0;
}

void CPocketSendDlg::OnCart2File() 
{
	if((DetectSize() >> 19) == 0)  //the lower 19 bits should all be 0, anyway
	{
		AfxMessageBox("Please insert a cart before reading!");
		return;
	}

	// TODO: Add your control notification handler code here
	CFileDialog outFile(false, "ngp", "*.ngp", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "NGPC Files (*.ngp)|*.ngp|All Files (*.*)|*.*||", this);
	if(outFile.DoModal() == IDCANCEL)
		return;
	
	readFile = outFile.GetPathName();
	AfxBeginThread( ActionReadThread, this ); 
}

void CPocketSendDlg::OnAbout() 
{
	CAboutDlg *dlg = new CAboutDlg;
	dlg->DoModal();
}

void CPocketSendDlg::OnAddFiles() 
{
	// similar to drag-n-drop
	CFileDialog inFile(true, "ngp", "*.ngp", OFN_ALLOWMULTISELECT | OFN_READONLY | OFN_HIDEREADONLY, "NGPC Files (*.ngp)|*.ngp|All Files (*.*)|*.*||", this);
	if(inFile.DoModal() == IDCANCEL)
		return;

	CString fileNames[100];
	unsigned int numFiles = 0;

	POSITION pos = inFile.GetStartPosition();
	while(pos != NULL)
	{
		//fileNames[numFiles] = new CString;
		fileNames[numFiles] = inFile.GetNextPathName(pos);
		numFiles++;
	}

	AddFiles(numFiles, fileNames );
}

void CAboutDlg::OnUrl() 
{
	ShellExecute(GetSafeHwnd(), "open", FLAVOR_URL, NULL, NULL, SW_SHOWNORMAL);
}

void CPocketSendDlg::EnableLinkerButtons(bool enable) 
{
	static int menu2cartEnabled = false;

	if(linkerPresent == false)
		enable = false;

	if(Menu2CartButton != NULL)
	{
		if(!enable)
		{
			menu2cartEnabled = Menu2CartButton->IsWindowEnabled();
			Menu2CartButton->EnableWindow(false);
		}
		else
			Menu2CartButton->EnableWindow(menu2cartEnabled);
	}
	if(File2CartButton != NULL)
		File2CartButton->EnableWindow(enable);
	if(Cart2FileButton != NULL)
		Cart2FileButton->EnableWindow(enable);
}

void CPocketSendDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CDialog::OnTimer(nIDEvent);
	if ((nIDEvent == POLL_TIMER) && !sending)  //don't do any polling if we're sending
	{
		GetDlgItem(IDC_CARTSIZE)->SetWindowText(GetCartSizeString());		
		GetDlgItem(IDC_CARTNAME)->SetWindowText(GetCartNameString());		
	}
}

HBRUSH CAboutDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr;
	LONG id;
	switch (nCtlColor)
	{
	case CTLCOLOR_STATIC:
		id = GetWindowLong(pWnd->m_hWnd,GWL_ID);
		if(id == IDC_URL) 
		{
			if(m_bOverControl)
				pDC->SetTextColor (RGB(0,0,0x7F)); // darker blue text
			else
				pDC->SetTextColor (RGB(0,0,0xFF)); // blue text
			pDC->SetBkMode (TRANSPARENT);
			hbr = (HBRUSH)GetStockObject(NULL_BRUSH);
		}
		else
		{
			hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
		}
		break;
	default:
		hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
		break;
	}
	return hbr;
}

void CAboutDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
    m_Font.DeleteObject();	
}

HBRUSH CPocketSendDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr;
	LONG id;
	switch (nCtlColor)
	{
	case CTLCOLOR_STATIC:
		id = GetWindowLong(pWnd->m_hWnd,GWL_ID);
		if(id == IDC_LIKSANG) 
		{
			if(m_bOverControl)
				pDC->SetTextColor (RGB(0,0,0x7F)); // darker blue text
			else
				pDC->SetTextColor (RGB(0,0,0xFF)); // blue text
			pDC->SetBkMode (TRANSPARENT);
			hbr = (HBRUSH)GetStockObject(NULL_BRUSH);
		}
		else
		{
			hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
		}
		break;
	default:
		hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
		break;
	}
	return hbr;
}

void CPocketSendDlg::OnDestroy() 
{
	CDialog::OnDestroy();
    m_Font.DeleteObject();	
}

void CPocketSendDlg::OnLiksangClicked() 
{
	ShellExecute(GetSafeHwnd(), "open", LIKSANG_URL, NULL, NULL, SW_SHOWNORMAL);
}

void CAboutDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	CDialog::OnMouseMove(nFlags, point);

    CRect rect;
    GetDlgItem(IDC_URL)->GetWindowRect(rect);
	ScreenToClient(rect);
	BOOL inRect = rect.PtInRect(point);

	if(m_bOverControl && !inRect)
	{
		m_bOverControl = FALSE;
		ReleaseCapture();
		GetDlgItem(IDC_URL)->RedrawWindow();
	}
	else if(!m_bOverControl && inRect)
	{
		m_bOverControl = TRUE;
		GetDlgItem(IDC_URL)->RedrawWindow();
		SetCapture();
	}
}

void CAboutDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonUp(nFlags, point);
}

void CAboutDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonDown(nFlags, point);

    CRect rect;
    GetDlgItem(IDC_URL)->GetWindowRect(rect);
	ScreenToClient(rect);
	BOOL inURLRect = rect.PtInRect(point);

	if(inURLRect)
		OnUrl();
	
    GetDlgItem(IDC_LIKSANG_BMP)->GetWindowRect(rect);
	ScreenToClient(rect);
	BOOL inLikRect = rect.PtInRect(point);
	
	if(inLikRect)
		ShellExecute(GetSafeHwnd(), "open", LIKSANG_URL, NULL, NULL, SW_SHOWNORMAL);
}

void CPocketSendDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	CDialog::OnMouseMove(nFlags, point);

    CRect rect;
    GetDlgItem(IDC_LIKSANG)->GetWindowRect(rect);
	ScreenToClient(rect);
	BOOL inRect = rect.PtInRect(point);

	if(m_bOverControl && !inRect)
	{
		m_bOverControl = FALSE;
		ReleaseCapture();
		GetDlgItem(IDC_LIKSANG)->RedrawWindow();
	}
	else if(!m_bOverControl && inRect)
	{
		m_bOverControl = TRUE;
		GetDlgItem(IDC_LIKSANG)->RedrawWindow();
		SetCapture();
	}
}

void CPocketSendDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonDown(nFlags, point);

    CRect rect;
    GetDlgItem(IDC_LIKSANG)->GetWindowRect(rect);
	ScreenToClient(rect);
	BOOL inURLRect = rect.PtInRect(point);

	if(inURLRect)
	{
		OnLiksangClicked();
	}
}


void CPocketSendDlg::OnPortButton() 
{
	// TODO: Add your control notification handler code here
	CPortSettingsDlg *dlg = new CPortSettingsDlg;
	char initialStr[6], secondStr[6];

	GetDlgItem(IDC_PORT_BUTTON)->GetWindowText(initialStr, 6);

	dlg->DoModal();

	GetDlgItem(IDC_PORT_BUTTON)->GetWindowText(secondStr, 6);

	if(strncmp(secondStr, initialStr, 5) != 0)
		initLinker();
}


/////////////////////////////////////////////////////////////////////////////
// CPortSettingsDlg dialog

CPortSettingsDlg::CPortSettingsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPortSettingsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPortSettingsDlg)
	m_PortAddressXFer = _T("");
	//}}AFX_DATA_INIT
}


void CPortSettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPortSettingsDlg)
	DDX_Text(pDX, IDC_PORT_VAL_EDIT, m_PortAddressXFer);
	DDV_MaxChars(pDX, m_PortAddressXFer, 5);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPortSettingsDlg, CDialog)
	//{{AFX_MSG_MAP(CPortSettingsDlg)
	ON_BN_CLICKED(IDC_PORT_VAL_0X278, OnPortVal0x278)
	ON_BN_CLICKED(IDC_PORT_VAL_0X378, OnPortVal0x378)
	ON_BN_CLICKED(IDC_PORT_VAL_0X2E8, OnPortVal0x2e8)
	ON_BN_CLICKED(IDC_PORT_VAL_0X2F8, OnPortVal0x2f8)
	ON_BN_CLICKED(IDC_PORT_VAL_0X3BC, OnPortVal0x3bc)
	ON_BN_CLICKED(IDC_PORT_VAL_0X3E8, OnPortVal0x3e8)
	ON_BN_CLICKED(IDC_PORT_VAL_0X3F8, OnPortVal0x3f8)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPortSettingsDlg message handlers

void CPortSettingsDlg::OnPortVal0x378() 
{
	// TODO: Add your control notification handler code here
	//change IDC_PORT_VAL_EDIT
	GetDlgItem(IDC_PORT_VAL_EDIT)->SetWindowText("0x378");
}

void CPortSettingsDlg::OnPortVal0x278() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_PORT_VAL_EDIT)->SetWindowText("0x278");
}


void CPortSettingsDlg::OnPortVal0x2e8() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_PORT_VAL_EDIT)->SetWindowText("0x2E8");
}

void CPortSettingsDlg::OnPortVal0x2f8() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_PORT_VAL_EDIT)->SetWindowText("0x2F8");
}

void CPortSettingsDlg::OnPortVal0x3bc() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_PORT_VAL_EDIT)->SetWindowText("0x3BC");
	
}

void CPortSettingsDlg::OnPortVal0x3e8() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_PORT_VAL_EDIT)->SetWindowText("0x3E8");
	
}

void CPortSettingsDlg::OnPortVal0x3f8() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_PORT_VAL_EDIT)->SetWindowText("0x3F8");
	
}

BOOL CPortSettingsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	char tempStr[6];	
	GetParent()->GetDlgItem(IDC_PORT_BUTTON)->GetWindowText(tempStr, 6);
	GetDlgItem(IDC_PORT_VAL_EDIT)->SetWindowText(tempStr);


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPortSettingsDlg::OnOK() 
{
	// TODO: Add extra validation here

	char tempStr[6];	
	GetDlgItem(IDC_PORT_VAL_EDIT)->GetWindowText(tempStr, 6);

	GetParent()->GetDlgItem(IDC_PORT_BUTTON)->SetWindowText(tempStr);

	CDialog::OnOK();
}